<script setup lang="ts">
import { useProductStore } from '../stores/product'
import LoadingDialog from '@/components/LoadingDialog.vue'
import { onMounted, ref } from 'vue'
import { useCategoryStore } from '../stores/category'
import SearchTableField from '@/components/SearchTableField.vue'
import ProductDialog from '../components/ProductDialog.vue'
const ProductStore = useProductStore()
const categoryStore = useCategoryStore()

const searchText = ref()

onMounted(async () => {
  await ProductStore.getAll()
  await categoryStore.getCategories()
})

function handleSearchText(value: string) {
  searchText.value = value
}
</script>

<template>
  <ProductDialog />
  <LoadingDialog />
  <v-data-table
    class="h-100"
    fixed-header
    :headers="ProductStore.headers"
    :items="ProductStore.items"
  >
    <template #top>
      <v-card class="pa-5" color="#77625d">
        <v-row>
          <v-col cols="11">
            <h2>Product Management</h2>
          </v-col>
          <v-col cols="1">
            <v-btn
              prepend-icon="mdi-plus"
              color="#FFD180"
              rounded="xl"
              class="w-100"
              @click="ProductStore.openDialog()"
              >New</v-btn
            >
          </v-col>
          <v-col cols="6">
            <SearchTableField @get-search-text="handleSearchText" />
          </v-col>
        </v-row>
      </v-card>
    </template>

    <template #item="{ item }">
      <tr>
        <td>{{ item.id }}</td>
        <td>
          <v-img
            :src="'http://localhost:3000/images/products/' + item.image"
            width="100"
            height="100"
          ></v-img>
        </td>
        <td>{{ item.name }}</td>
        <td>{{ item.price }}</td>
        <td>{{ item.category.name }}</td>

        <td>
          <v-icon size="small" class="me-2" @click="ProductStore.editItem(item)">
            mdi-pencil
          </v-icon>
          <v-icon size="small" @click="ProductStore.deleteItem(item)"> mdi-delete </v-icon>
        </td>
      </tr>
    </template>
  </v-data-table>
</template>
